﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace WindowsFormsApplication61
{
    public class TempFileManager : IDisposable
    {
        #region Private Members
        private List<FileInfo> filesToCleanUp;
        #endregion // Private Members

        #region FilesToCleanUp
        private List<FileInfo> FilesToCleanUp
        {
            get
            {
                if (null == filesToCleanUp)
                    filesToCleanUp = new List<FileInfo>();

                return filesToCleanUp;
            }
        }
        #endregion // FilesToCleanUp

        #region GetTempFile
        public FileInfo GetTempFile(string extension)
        {
            string filename = Path.GetTempFileName();
            filename = Path.ChangeExtension(filename, extension);
            var fileInfo = new FileInfo(filename);
            FilesToCleanUp.Add(fileInfo);
            return fileInfo;
        }
        #endregion // GetTempFile

        #region Dispose
        public void Dispose()
        {
            if (null != filesToCleanUp)
            {
                foreach (var fi in filesToCleanUp)
                    fi.Delete();
            }
        } 
        #endregion // Dispose
    }
}
